<template>
  <div class="confirmRegistration">
    <h1>Confirm your e-mail</h1>
    <p>
      Thank you for your <router-link to="/register">registration</router-link>!
      Check your inbox, we sent you a confirmation code to complete the setup.
      If you have already done so, you can simply
      <router-link to="/login">log in</router-link>.
    </p>

    <b-form @submit="sendConfirmation">
      <b-row>
        <b-col md="6">
          <b-form-input
            v-model="code"
            :state="validConfirmFormat"
            placeholder="Confirmation code"
            trim
          />
        </b-col>
        <b-col md="6">
          <b-form-input
            v-model="email"
            :state="validEmailFormat"
            placeholder="Enter your E-Mail address"
            trim
          />
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <b-form-input
            type="password"
            v-model="password"
            :state="validPasswordFormat"
            placeholder="Enter your Password"
            trim
          />
        </b-col>
      </b-row>
      <b-button
        type="submit"
        variant="primary"
        :disabled="
          !(validConfirmFormat && validEmailFormat && validPasswordFormat)
        "
      >
        Confirm registration
      </b-button>
    </b-form>

    <p v-show="error" style="color: red; margin-top: 1em;">
      Something went wrong, please double-check your input or try it later
      again. Error message: {{ error }}
    </p>
  </div>
</template>

<script>
import gql from "graphql-tag";

export default {
  computed: {
    validConfirmFormat() {
      return /^\d{6}$/.test(this.code);
    },
    validPasswordFormat() {
      return this.password.length >= 10;
    },
    validEmailFormat() {
      return /\S+@\S+\.\S+/.test(this.email);
    }
  },
  data() {
    return {
      error: null,
      password: "",
      email: "",
      code: ""
    };
  },
  methods: {
    getToken() {
      return localStorage.getItem("OC_AUTH_TOKEN") || null;
    },
    sendConfirmation(evt) {
      evt.preventDefault();
      this.error = "";
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($email: String!, $password: String!, $code: String!) {
              confirmEmail(email: $email, password: $password, code: $code)
            }
          `,
          variables: {
            email: this.email,
            password: this.password,
            code: this.code
          }
        })
        .then(data => {
          localStorage.setItem("OC_AUTH_TOKEN", data.data.confirmEmail);
          // Do not use router to force re-rendering the login and account nav elements
          window.location.href = "/account";
        })
        .catch(error => {
          this.error = error;
        });
    }
  },
  created() {
    if (this.getToken()) {
      // Do not use router to force re-rendering the login and account nav elements
      window.location.href = "/account";
    }
  }
};
</script>
